# mypy-boto3-apigatewayv2

[![PyPI - mypy-boto3-apigatewayv2](https://img.shields.io/pypi/v/mypy-boto3-apigatewayv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-apigatewayv2)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-apigatewayv2.svg?color=blue)](https://pypi.org/project/mypy-boto3-apigatewayv2)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-apigatewayv2](#mypy-boto3-apigatewayv2)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.ApiGatewayV2 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/apigatewayv2.html#ApiGatewayV2) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-apigatewayv2](#mypy-boto3-apigatewayv2)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `ApiGatewayV2` service.

```bash
python -m pip install boto3-stubs[apigatewayv2]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_apigatewayv2` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_apigatewayv2 import ApiGatewayV2Client

# Now mypy can check if your code is valid.
client: ApiGatewayV2Client = boto3.client("apigatewayv2")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: ApiGatewayV2Client = session.client("apigatewayv2")



# Annotated paginators are included as well

import mypy_boto3_apigatewayv2.paginator as apigatewayv2_paginators

get_apis_paginator: apigatewayv2_paginators.GetApisPaginator = client.get_paginator("get_apis")
get_authorizers_paginator: apigatewayv2_paginators.GetAuthorizersPaginator = client.get_paginator("get_authorizers")
get_deployments_paginator: apigatewayv2_paginators.GetDeploymentsPaginator = client.get_paginator("get_deployments")
get_domain_names_paginator: apigatewayv2_paginators.GetDomainNamesPaginator = client.get_paginator("get_domain_names")
get_integration_responses_paginator: apigatewayv2_paginators.GetIntegrationResponsesPaginator = client.get_paginator("get_integration_responses")
get_integrations_paginator: apigatewayv2_paginators.GetIntegrationsPaginator = client.get_paginator("get_integrations")
get_models_paginator: apigatewayv2_paginators.GetModelsPaginator = client.get_paginator("get_models")
get_route_responses_paginator: apigatewayv2_paginators.GetRouteResponsesPaginator = client.get_paginator("get_route_responses")
get_routes_paginator: apigatewayv2_paginators.GetRoutesPaginator = client.get_paginator("get_routes")
get_stages_paginator: apigatewayv2_paginators.GetStagesPaginator = client.get_paginator("get_stages")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_apigatewayv2` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_apigatewayv2 as apigatewayv2
from mypy_boto3_apigatewayv2 import ApiGatewayV2Client

# with these
from mypy_boto3 import apigatewayv2
from mypy_boto3.apigatewayv2 import ApiGatewayV2Client
```